﻿using System.IO;
using System.Windows;

namespace TestProject
{
    /// <summary>
    /// SVG 데이터
    /// </summary>
    public class SVGData
    {
        //////////////////////////////////////////////////////////////////////////////////////////////////// Field
        ////////////////////////////////////////////////////////////////////////////////////////// Private

        #region Field

        /// <summary>
        /// 파일 경로
        /// </summary>
        private string filePath;

        /// <summary>
        /// 변환 객체
        /// </summary>
        private DependencyObject convertedObject;

        /// <summary>
        /// 객체명
        /// </summary>
        private string objectName;

        /// <summary>
        /// SVG 데이터
        /// </summary>
        private string svg;

        /// <summary>
        /// XAML 데이터
        /// </summary>
        private string xaml;

        #endregion

        //////////////////////////////////////////////////////////////////////////////////////////////////// Property
        ////////////////////////////////////////////////////////////////////////////////////////// Public

        #region 파일 경로 - FilePath

        /// <summary>
        /// 파일 경로
        /// </summary>
        public string FilePath
        {
            get
            {
                return this.filePath;
            }
            set
            {
                this.filePath = value;
            }
        }

        #endregion
        #region 변환 객체 - ConvertedObject

        /// <summary>
        /// 변환 객체
        /// </summary>
        public DependencyObject ConvertedObject
        {
            get
            {
                if(this.convertedObject == null)
                {
                    this.convertedObject = SVGHelper.GetObject
                    (
                        this.filePath,
                        ConversionMode.DrawingImage,
                        null,
                        out this.objectName,
                        new ResourceKeyInfo()
                    ) as DependencyObject;
                }

                return this.convertedObject;
            }
            set
            {
                this.convertedObject = value;
            }
        }

        #endregion
        #region SVG - SVG

        /// <summary>
        /// SVG
        /// </summary>
        public string SVG
        {
            get
            {
                return this.svg ?? (this.svg = File.ReadAllText(this.filePath));
            }
            set
            {
                this.svg = value;
            }
        }

        #endregion
        #region XAML - XAML

        /// <summary>
        /// XAML
        /// </summary>
        public string XAML
        {
            get
            {
                return this.xaml ?? (this.xaml = SVGHelper.GetXAML(ConvertedObject, false, this.objectName, false));
            }
            set
            {
                this.xaml = value;
            }
        }

        #endregion
    }
}